
package com.company.model;

import java.time.LocalDate;
import javax.persistence.Column;
import javax.persistence.Convert;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.persistence.Version;


/**
 * 
 */
@javax.persistence.Entity(name = "TravelRequest")
@Table(name = "TRAVELREQUEST")
@NamedQueries({
    @NamedQuery(name = "TravelRequest.findByPersistenceId", query = "SELECT t\nFROM TravelRequest t\nWHERE t.persistenceId= :persistenceId\n"),
    @NamedQuery(name = "TravelRequest.findByUserId", query = "SELECT t\nFROM TravelRequest t\nWHERE t.userId= :userId\nORDER BY t.persistenceId"),
    @NamedQuery(name = "TravelRequest.findByDepartureDate", query = "SELECT t\nFROM TravelRequest t\nWHERE t.departureDate= :departureDate\nORDER BY t.persistenceId"),
    @NamedQuery(name = "TravelRequest.findByNumberOfNights", query = "SELECT t\nFROM TravelRequest t\nWHERE t.numberOfNights= :numberOfNights\nORDER BY t.persistenceId"),
    @NamedQuery(name = "TravelRequest.findByHotelNeeded", query = "SELECT t\nFROM TravelRequest t\nWHERE t.hotelNeeded= :hotelNeeded\nORDER BY t.persistenceId"),
    @NamedQuery(name = "TravelRequest.findByDestination", query = "SELECT t\nFROM TravelRequest t\nWHERE t.destination= :destination\nORDER BY t.persistenceId"),
    @NamedQuery(name = "TravelRequest.findByReason", query = "SELECT t\nFROM TravelRequest t\nWHERE t.reason= :reason\nORDER BY t.persistenceId"),
    @NamedQuery(name = "TravelRequest.findByStatus", query = "SELECT t\nFROM TravelRequest t\nWHERE t.status= :status\nORDER BY t.persistenceId"),
    @NamedQuery(name = "TravelRequest.findByRefusalReason", query = "SELECT t\nFROM TravelRequest t\nWHERE t.refusalReason= :refusalReason\nORDER BY t.persistenceId"),
    @NamedQuery(name = "TravelRequest.find", query = "SELECT t\nFROM TravelRequest t\nORDER BY t.persistenceId"),
    @NamedQuery(name = "TravelRequest.countForFindByUserId", query = "SELECT COUNT(t)\nFROM TravelRequest t\nWHERE t.userId= :userId\n"),
    @NamedQuery(name = "TravelRequest.countForFindByDepartureDate", query = "SELECT COUNT(t)\nFROM TravelRequest t\nWHERE t.departureDate= :departureDate\n"),
    @NamedQuery(name = "TravelRequest.countForFindByNumberOfNights", query = "SELECT COUNT(t)\nFROM TravelRequest t\nWHERE t.numberOfNights= :numberOfNights\n"),
    @NamedQuery(name = "TravelRequest.countForFindByHotelNeeded", query = "SELECT COUNT(t)\nFROM TravelRequest t\nWHERE t.hotelNeeded= :hotelNeeded\n"),
    @NamedQuery(name = "TravelRequest.countForFindByDestination", query = "SELECT COUNT(t)\nFROM TravelRequest t\nWHERE t.destination= :destination\n"),
    @NamedQuery(name = "TravelRequest.countForFindByReason", query = "SELECT COUNT(t)\nFROM TravelRequest t\nWHERE t.reason= :reason\n"),
    @NamedQuery(name = "TravelRequest.countForFindByStatus", query = "SELECT COUNT(t)\nFROM TravelRequest t\nWHERE t.status= :status\n"),
    @NamedQuery(name = "TravelRequest.countForFindByRefusalReason", query = "SELECT COUNT(t)\nFROM TravelRequest t\nWHERE t.refusalReason= :refusalReason\n"),
    @NamedQuery(name = "TravelRequest.countForFind", query = "SELECT COUNT(t)\nFROM TravelRequest t\n"),
    @NamedQuery(name = "TravelRequest.findByUserIdAndStatus", query = "SELECT t \nFROM TravelRequest t \nWHERE t.userId = :userId\nAND t.status = :status\nORDER BY t.persistenceId ASC")
})
public class TravelRequest implements org.bonitasoft.engine.bdm.Entity
{

    @Id
    @GeneratedValue
    private Long persistenceId;
    @Version
    private Long persistenceVersion;
    @Column(name = "USERID", nullable = false)
    private Long userId;
    @Column(name = "DEPARTUREDATE", nullable = false, length = 10)
    @Convert(converter = org.bonitasoft.engine.business.data.generator.DateConverter.class)
    private LocalDate departureDate;
    @Column(name = "NUMBEROFNIGHTS", nullable = false)
    private Integer numberOfNights;
    @Column(name = "HOTELNEEDED", nullable = false)
    private Boolean hotelNeeded;
    @Column(name = "DESTINATION", nullable = false, length = 255)
    private String destination;
    @Column(name = "REASON", nullable = false, length = 255)
    private String reason;
    @Column(name = "STATUS", nullable = false, length = 255)
    private String status;
    @Column(name = "REFUSALREASON", nullable = true, length = 255)
    private String refusalReason;

    public TravelRequest() {
    }

    public void setPersistenceId(Long persistenceId) {
        this.persistenceId = persistenceId;
    }

    public Long getPersistenceId() {
        return persistenceId;
    }

    public void setPersistenceVersion(Long persistenceVersion) {
        this.persistenceVersion = persistenceVersion;
    }

    public Long getPersistenceVersion() {
        return persistenceVersion;
    }

    public void setUserId(Long userId) {
        this.userId = userId;
    }

    public Long getUserId() {
        return userId;
    }

    public void setDepartureDate(LocalDate departureDate) {
        this.departureDate = departureDate;
    }

    public LocalDate getDepartureDate() {
        return departureDate;
    }

    public void setNumberOfNights(Integer numberOfNights) {
        this.numberOfNights = numberOfNights;
    }

    public Integer getNumberOfNights() {
        return numberOfNights;
    }

    public void setHotelNeeded(Boolean hotelNeeded) {
        this.hotelNeeded = hotelNeeded;
    }

    public Boolean isHotelNeeded() {
        return hotelNeeded;
    }

    public void setDestination(String destination) {
        this.destination = destination;
    }

    public String getDestination() {
        return destination;
    }

    public void setReason(String reason) {
        this.reason = reason;
    }

    public String getReason() {
        return reason;
    }

    public void setStatus(String status) {
        this.status = status;
    }

    public String getStatus() {
        return status;
    }

    public void setRefusalReason(String refusalReason) {
        this.refusalReason = refusalReason;
    }

    public String getRefusalReason() {
        return refusalReason;
    }

}
