
package com.company.model;

import java.time.LocalDate;
import java.util.List;
import org.bonitasoft.engine.bdm.dao.BusinessObjectDAO;

public interface TravelRequestDAO
    extends BusinessObjectDAO
{


    public TravelRequest findByPersistenceId(Long persistenceId);

    public List<TravelRequest> findByUserId(Long userId, int startIndex, int maxResults);

    public List<TravelRequest> findByDepartureDate(LocalDate departureDate, int startIndex, int maxResults);

    public List<TravelRequest> findByNumberOfNights(Integer numberOfNights, int startIndex, int maxResults);

    public List<TravelRequest> findByHotelNeeded(Boolean hotelNeeded, int startIndex, int maxResults);

    public List<TravelRequest> findByDestination(String destination, int startIndex, int maxResults);

    public List<TravelRequest> findByReason(String reason, int startIndex, int maxResults);

    public List<TravelRequest> findByStatus(String status, int startIndex, int maxResults);

    public List<TravelRequest> findByRefusalReason(String refusalReason, int startIndex, int maxResults);

    public List<TravelRequest> find(int startIndex, int maxResults);

    public Long countForFindByUserId(Long userId);

    public Long countForFindByDepartureDate(LocalDate departureDate);

    public Long countForFindByNumberOfNights(Integer numberOfNights);

    public Long countForFindByHotelNeeded(Boolean hotelNeeded);

    public Long countForFindByDestination(String destination);

    public Long countForFindByReason(String reason);

    public Long countForFindByStatus(String status);

    public Long countForFindByRefusalReason(String refusalReason);

    public Long countForFind();

    public List<TravelRequest> findByUserIdAndStatus(Long userId, String status, int startIndex, int maxResults);

    public TravelRequest newInstance(Long userId, LocalDate departureDate, Integer numberOfNights, Boolean hotelNeeded, String destination, String reason, String status);

}
